require'wrapper.rb'
public

def section(a=$section)
  $section=a
end
section(All)

Trigger = Struct.new(:pl, :conditions, :actions)
class Trigger
  def finalize
    'Trigger(%s){
Conditions:
%sActions:
%s}

'%[pl.to_player, conditions.map{|i|' '*4+i.finalize}, actions.map{|i|' '*4+i.finalize}]
  end
  def citric? #is preserved?
    actions.any?{|i|i==pt}
  end
end

def getatoms(*args, &b)
  if b
    oldatoms = $atoms
    $atoms = []
    yield
    args.concat $atoms
    $atoms = oldatoms
  end
  args
end

$afters = []
def strig(*args, &b)
  actions = []
  conditions = []
  pl = section
  getatoms(*args, &b).flatten.each{|a|
    case a
    when Action
      actions<<a
    when Condition
      conditions<<a
    else
      #abort("for now disabled setting section on the fly")
      pl = a
    end
  }
  conditions = [always] if conditions == []
  return if actions-[pt] == []
  Trigger.new(pl, conditions, actions)
end

$triggers = []
def trig(*args, &b)
  r=strig(*args, &b)
  return if !r
  $triggers << r
  $afters.shift[r] until $afters.empty?
  r
end

def ptrig(*a, &b)
  trig(preservetrigger, *a, &b)
end

def hypertriggers
  3.times{ ptrig([wait(0)]*63) }
end

#abstractions, simulatedwait, syncro, once, oncepc, burrow array, add, mult, subt, binarycutoff, etc

#auto trig, with func to capture

#trigger in trigger (nested if)

#global var (uses only 1 players death counts, upto 8 can be used

#make declarations possible anywhere

#more than 64 actions, conditions


  #todo condions, or actions > 64 auto handle
  #array of triggers?

#message comment to map editors as first action

makeValueFrom(:Vision, nil, nil)
class VisionClass
  def set
    aiscript("+Vi%d"%(player-1))
  end
  def clear
    aiscript("-Vi%d"%(player-1))
  end
  def +(i)
  	of(i).set
  end
  def -(i)
  	of(i).clear
  end
end

$varhash = {}
def getvar(i)
  $varhash[i]||=$unused.pop
end

$globalvarhash = {}
$lastglobal = nil
def getglobalvar(i)
  $globalvarhash[i]||=(
    pl = $globalvarhash.size % 8
    $lastglobal = getvar(~i) if pl == 0
    [$lastglobal, (pl+1).to_player.to_s]
  )
end

VarClass = Struct.new(:number)
class VarClass
  def to_unit
    self
  end
  def finalize
    getvar(number)
  end
end
$varsused = 0
def var
  r=deaths
  r.unit = VarClass.new(-1+$varsused+=1)
  r
end

GlobalVarPlayerClass = Struct.new(:number)
class GlobalVarPlayerClass
  def to_player
    self
  end
  def finalize
    getglobalvar(number)[1]
  end
end
class GlobalVarUnitClass < VarClass
  def finalize
    getglobalvar(number)[0]
  end
end

$globalvars = 0
def globalvar
  r=deaths
  r.unit = GlobalVarUnitClass.new($globalvars)
  r.player = GlobalVarPlayerClass.new(-1+$globalvars+=1)
  r
end

$switchesused = 0
def switch
  Switch[$switchesused+=1]
end

UnitsUsed = {}
def use(*a)
  a.flatten.map{|u|
    UnitsUsed[u.to_unit]=true
    u
  }
end

def unselect(via=11)
  [give(via), of(via).give(player)]
end

#execute an action when a unit enters or leaves a location
#guards can be either extra conditions or actions for both enter, leave
#example: Civilian.at("low resource").enterleavecallback(VoteLow-2, VoteLow+2)
def enterleavecallback(enter=[], leave=[], &guards)
  inside=var
  ptrig(inside.off?, on?, inside.set, *enter, &guards)
  ptrig(inside.on?, off?, inside.clear, *leave, &guards)
end

def once(*a, &b)
  executed = switch
  trig(executed.off?, executed.set, *a, &b)
end

def firstplayer
  $first_player ||= var
end
  

def ponce(*a, &b)
  ptrig(firstplayer.on?, *a, &b)
end

def crash
  AnyUnit.portrait(1000)
end

def allaction(*a)
  
end

def othersaction

end

def loopall(&b)
  (1..8).map(&b)
end

Max=30000
def binary(var, *args, &b)
  guards=[]
  guards<<args.shift while !args.empty? && Atom===args[0]
  max,min = *args
  max||=Max
  min||=1
  
  x=2**max.to_s(2).size/2
  
  while x>=min
    trig(var>=x, var-x, guards) { yield(x) }
    x/=2
  end
end

#run after current trigger generation is complete, yielding current trigger
def after(&b)
  $afters<<b
end
  
#all conds/actions must be in block, must use pt inside if if you want that to preserve too
def fi(&b)
  #could do a check and use a switch isntead of var if section is only 1 player
  part1 = var
  part1.set
  after{|t|
    trig(part1.on?, &b)
    if t.citric?
      t.conditions << part1.off?
      ptrig(part1.clear)
    end
  }
end

#for now manually add pt if section is for more than 1 player
#todo maybe pass who all to run it for as an arg
def runothers(&b)
  ran = var
  ran[All]+1
  ran-1
  after{|t|
    trig(ran.on?, ran-1, &b)
  }
end

def runall(&b)
  ran = var
  ran[All]+1
  after{|t|
    trig(ran.on?, ran-1, &b)
  }
end

def sync(&b) #like fi, a nested trigger, except dont try until next trigger cycle for all players
  #todo for now assume no preserve trigger
  part1 = switch
  part2 = switch
  part1.set
  after{|t|
    trig(firstplayer.on?, part1.on?, part2.set)
    trig(part2.on?, &b)
  }
end

#a simulated wait, used to do a wait while hyper triggers are active or instead of a wait so that replays do not break
#this does excessive var modifications if all players are doing it syncroniasiosuly
$swaitvars = []
def swait(cycles)
  #if last swait do the cleanup
  $atoms<<r=Action.new('swait', [cycles])
  after{|tr|
    last = nil
    tr.actions.each{|i|last = i if i.name=="swait"}
    if r.equal? last
      cit = tr.citric?
      total=0
      t=tr.actions.split_by{|i|total+=i.args[0] if i.name=="swait"}
      $swaitvars << waitvar = var
      tr.conditions<<waitvar.off?
      newtotal = total - t[0].pop.args[0]
      tr.actions=t[0]
      tr.actions<<pt if cit
      tr.actions<<waitvar.set(total+1)
      t[1..-1].each{|i|
        total = newtotal
        newtotal = total - i.pop.args[0] if i[-1] && i[-1].name=="swait"
        args=[waitvar^total+1, i]
        cit ? ptrig(args) : trig(args)
      }
      
    end
  }
  r
end

class Array
  def split_by(&b)
    results=[[]]
    each{|i|
      results[-1]<<i
      results<<[] if yield(i)
    }
    results
  end
end


END{
  $unused = UnitNames.map{|i|i.to_unit}-UnitsUsed.keys
  
  trigs = $triggers
  $triggers = []
  
  section [All, 1..8]
  trig(never, comment("triggers automatically generated using: http://www.golfscript.com/rubytrigs/"))
  section All
  
  if $first_player
    trig($first_player[All].off?) { $first_player.set }
  end
  
  ptrig($swaitvars.map{|v|v-1})
  
  orig=File.read("out.txt")
  file=File.open("out.txt",'w')
  nt=lines=0
  ($triggers+trigs).each{|t|
    nt+=1
    file.puts s = t.finalize
    lines+=s.to_a.size
  }
  puts "done, %d triggers, %d lines" % [nt, lines]
  puts "switches = %d, vars = %d, globalvars = %d" % [$switchesused, $varsused, $globalvars]
  file.close
  curr=File.read("out.txt")
  puts "output is #{curr==orig ? "same as" : "different then"} before"
  
  curr=curr.to_a
  orig=orig.to_a
  difflines=1
  curr.size.times{|i|
  if !orig[i]||curr[i].downcase!=orig[i].downcase
    puts curr[i]
    puts orig[i]
    break if 0>difflines-=1
  end
  }
}