require'units.rb'

Atom = Struct.new(:name, :args)
class Atom
  def finalize
    name.gsub(/[A-Z][a-z]/,' \&').gsub(/[A-Z]{2,}/,' \&').strip+'('+
      args.map{|i|i.finalize}*', '+");\n"
  end
end
class Condition < Atom
end
class Action < Atom
end

def toconst(s)
  s.to_s.split.map{|i|i.capitalize}.join.tr('^a-zA-Z','')
end

def tofunc(s)
  s.to_s.downcase.tr('^a-z','')
end

actions=File.read('actions.lst').scan(/^(?:Condition|Action) (.*)/).flatten
conditions=File.read('conditions.lst').scan(/^(?:Condition|Action) (.*)/).flatten

$atoms = []
[[actions,'Action'],[conditions,'Condition']].each{|list,classname|list.each{|a|
  a[/^(.*)\((.*)\)$/]
  name = $1
  #puts name
  args = $2.split(/, /)
  args = args.map{|b|b.split}
  s=%Q{
  def #{tofunc(name)}(#{args.map{|type,iden|tofunc(iden)}*','})
    r=#{classname}.new('#{name}', [#{args.map{|type,iden|
      tofunc(iden)+".to_"+tofunc(type)}*', '}])
    $atoms<<r
    r
  end
 }
 eval s
}}

stringTypes = %w'Unit Location String Player Switch AIScript AIScriptAt'

stringTypes.each{|i|
  eval %Q{
  class String
    alias #{"to_"+tofunc(i)} inspect
  end
 }
}

enumTypes = {
  :Modifier => %w'set\ to add subtract',
  :SwitchAction => %w'toggle randomize clear set',
  :Score => ['buildings', 'custom', 'kills', 'kills and razings', 'razings', 'total', 'units', 'units and buildings'],
  :Resource => ['ore','gas','ore and gas'],
  :Order => %w'patrol attack move',
  :AllyStatus => %w'Ally Enemy Allied\ Victory',
  :PropState => %w'disabled enabled toggle\ prop',
  :DisplayBool => %w"always\ display don't\ always\ display",
  
  :Comparison => %w'at\ least at\ most exactly',
  :SwitchState => %w'on off',
  
}

module EnumFunctions
end

enumTypes.each{|type, values|
  eval %Q{
  class #{type}
    def initialize(t); @type = t; end
    attr_reader :type
    attr_writer :type
    include EnumFunctions
    def to_#{tofunc(type.to_s)}; self; end
    def to_s; @type.to_s; end
  end
  }
  
  values.each{|v|
    eval %Q{
    #{toconst(v)} = #{type}.new(%p)
  } % v
  }
}
  
On.type="set"
Off.type="not set"
ToggleProp.type = "toggle"

