require'bindings.rb'

public
def finalize
  to_s
end

def attribute(*a)
  eval 'def %s; @%s; end; def %s=v; @%s=v; end; '*a.size%a.map{|i|[i]*4}.flatten
end
alias fn lambda
attribute(:unit, :location, :player)

class SwitchAction
  def to_propstate
    case self
    when Toggle
      ToggleProp
    when Randomize
      abort'cannot randomize PropState'
    when Clear
      Disabled
    when Set
      Enabled
    end
  end
end

class Integer
  alias to_count to_i
  def to_number
    self
  end
  def to_player
    '"player %d"'%self
  end
  def to_propstate
    self == 0 ? Disabled : Enabled
  end
  def to_switch
    '"switch%d"'%self
  end
  def to_switchaction
    self == 0 ? Clear : Set
  end
  def to_switchstate
    self == 0 ? Off : On
  end
  def to_allystatus
    self == 0 ? Enemy : AlliedVictory
  end
  def dup
    self
  end
end

class NilClass
  def to_count
    "All"
  end
  def to_player
    CurrentPlayer.to_player
  end
  def to_unit
    :any.to_unit
  end
  def to_location
    Anywhere.to_location
  end
end

NameSearch = [['buildings', 'any unit', 'men', 'factories'],UnitNames-UnusedUnits-Powerups,Powerups,UnusedUnits].map{|j|j.sort_by{|i|i.sub(/terran|protoss|zerg/i,'').size}}.flatten.uniq
class Symbol
  def str
    u=tofunc(self)
    NameSearch.find{|i|tofunc(i)[u]}||abort("invalid unit %s"%self)
  end
  def to_unit
    str.inspect
  end
  def unit
    self
  end
  def dup
    r=Object.new
    r.unit = self
    r
  end
end

class Array
  def to_player
    map{|i|i.to_player}*','
  end
end
class Range
  def to_player
    to_a.to_player
  end
end

def location?
  @location != nil
end
def player?
  @player != nil
end

module Value
  def |(val)
    setter SetTo, val
  end
  def +(val)
    setter Add, val
  end
  def -(val)
    setter Subtract, val
  end
  def <(val)
    getter AtMost, val-1
  end
  def <=(val)
    getter AtMost, val
  end
  def >(val)
    getter AtLeast, val+1
  end
  def >=(val)
    getter AtLeast, val
  end
  def ^(val)
    getter Exactly, val
  end
  def +@ #curry like behavior
    lambda{|i|self+i}
  end
  def -@
    lambda{|i|self-i}
  end
  def set(val=1)
    self|val
  end
  def clear
    self|0
  end
  def on?
    self>0
  end
  def off?
    self<1
  end
  def toggle
    self|Toggle
  end
end
include Value

def [](pl)
  r=dup
  r.player=pl
  r
end
alias of []
def at(loc)
  r=dup
  r.location=loc
  r
end

AnyUnit=:any
AnyBuilding=:buildings
Men=:men
CurrentPlayer="current player"
All="all players"
Neutral="player 12"
Allies="Allies"
Foes="Foes"
Anywhere="Anywhere"

#ValueClass = Struct.new(:ename, :get, :set)
class ValueClass
  attribute(:getf, :setf)
  def initialize(g,s);@get=g;@set=s;end
  def getter(c,v)
    eval getf
  end
  def setter(s,v)
    eval setf
  end
  include Value
end

def makeValue(name, gs=nil, ss=nil)
  gs||="abort('cannot get %p')"%name
  ss||="abort('cannot set %p')"%name
  eval"class #{name}Class
  def getter(c,v)
    #{gs}
  end
  def setter(s,v)
    #{ss}
  end
  include Value
 end
 #{name}=#{name}Class.new"
end

def makeValueFrom(name, gs=nil, ss=nil)
  makeValue(name, gs, ss)
  eval"def #{tofunc(name)}
  #todo this can go
  r=#{name}.dup
  r.unit = unit
  r.player = player
  r.location = location
  r
 end"
end

makeValue(:Timer, "countdowntimer(c,v)", "setcountdowntimer(s,v)")
class TimerClass
  def pause; pausetimer; end
  def unpause; unpausetimer; end
end

makeValue(:ElapsedTime, "elapsedtime(c,v)")
makeValue(:Opponents, "opponents(player, c, v)")
alias killcond kill
makeValueFrom(:Kill)
class KillClass
  def getter(c, v)
    killcond(player, unit, c, v)
  end
  def setter(s, v)
    if s==Add
      unit+v
    elsif s==SetTo
      if v==0
        if location?
          self-nil
        else
          killunit(player, unit)
        end
      else
        [self|0,self+v]
      end
    else #Subtract'
      killunitatlocation(player, unit, v, location)
    end
  end
  def most
    mostkills(unit)
  end
  def least
    leastkills(unit)
  end
  def leaderboard(label="")
    leaderboardkills(label, unit)
  end
  def leaderboardgoal(goal, label="")
    leaderboardgoalkills(label, unit, goal)
  end
  include Value
end
alias deathscond deaths
makeValueFrom(:Deaths,"deathscond(player, unit, c, v)", "setdeaths(player, unit, s, v)")
makeValueFrom(:Invincibility, nil, "setinvincibility(player, unit, location, v)")
#switch uses player number as switch number
alias switchcond switch
makeValue(:Switch, nil, "setswitch(player, v)")
class SwitchClass
  def getter(c,v)
    case c
    when Exactly then switchcond(player, v)
    when AtLeast then self ^ v+1
    when AtMost then self ^ v
    end
  end
  def randomize
    self|Randomize
  end
end
makeValueFrom(:Alliance, nil, "setalliancestatus(player, v)")
makeValue(:LBCPU, nil, "leaderboardcomputerplayers(v)")
makeValueFrom(:Doodads, nil, "setdoodadstate(player, unit, location, v)")
alias setplayerresources setresources
class Resource
  def getter(c,v)
    accumulate(player, c, v, self)
  end
  def setter(s,v)
    setplayerresources(player, s, v, self)
  end
  def most
    mostresources(self)
  end
  def least
    leastresources(self)
  end
  def leaderboard(label="")
    leaderboardresources(label, self)
  end
  def leaderboardgoal(goal, label="")
    leaderboardgoalresources(label, goal, self)
  end
  include Value
end

class Score
  def getter(c,v)
    score(player, self, c, v)
  end
  def setter(s,v)
    setscore(player, s, v, self)
  end
  def most
    highestscore(self)
  end
  def least
    lowestscore(self)
  end
  def leaderboard(label="")
    leaderboardpoints(label, self)
  end
  def leaderboardgoal(goal, label="")
    leaderboardgoalpoints(label, self, goal)
  end
  include Value
end


def getter(c,v)
  if location?
    bring(player, unit, location, c, v)
  else
    command(player, unit, c, v)
  end
end
def setter(s,v)
  if s==Add
    createunit(player, unit, v, location)
  elsif s == SetTo
    if v==0
      if location?
        self-nil
      else
        removeunit(player, unit)
      end
    else
      [self|0,self+v]
    end
  else #Subtract'
    removeunitatlocation(player, unit, v, location)
  end
end

def most
  if location?
    commandsthemostat(unit,location)
  else
    commandthemost(unit)
  end
end
def least
  if location?
    commandstheleastat(unit,location)
  else
    commandtheleast(unit)
  end
end
def setenergy(amount=100,numunits = nil)
  modifyunitenergy(player, unit, amount, numunits, location)
end
def sethealth(amount=100,numunits = nil)
  modifyunithitpoints(player, unit, amount, numunits, location)
end
def setshields(amount=100,numunits = nil)
  modifyunitshieldpoints(player, unit, amount, numunits, location)
end
def setresources(amount=1500,numunits = nil)
  modifyunitresourceamount(player? ? player : Neutral, amount, numunits, location)
end
def sethangar(amount=8,numunits = nil)
  modifyunithangercounter(player, amount, numunits, location)
end
def portrait(time)
  talkingportrait(unit, time)
end
alias oldtran transmission
#todo find out what the add and time do, defaults better maybe
def transmission(wav, time=0, text="", add=Add, alw=AlwaysDisplay, unknown=0)
  transmission(alw, text, unit, location, add, time, wav, unknown)
end
alias oldorder order
def order(command, to=Anywhere)
  oldorder(player, unit, location, to, command)
end
def attack(to=Anywhere)
  order(Attack, to)
end
def patrol(to=Anywhere)
  order(Patrol, to)
end
def move(to=Anywhere)
  order(Move, to)
end
def leaderboard(label="")
  if location?
    leaderboardcontrolatlocation(label, unit, location)
  else
    leaderboardcontrol(label, unit)
  end
end
def leaderboardgoal(goal, label="")
  if location?
    leaderboardgoalcontrolatlocation(label, unit, goal, location)
  else
    leaderboardgoalcontrol(label, unit, goal)
  end
end
def teleport(to=Anywhere, count=nil)
  moveunit(player, unit, count, location, to)
end
def moveloc(name)
  movelocation(player, unit, location, name)
end
def give(reciever=CurrentPlayer, count=nil)
  giveunitstoplayer(player, reciever, unit, count, location)
end

#same, wait, leaderboardgreed, comment, 
alias pt preservetrigger
alias setmission setmissionobjectives
alias oldplaywav playwav
def playwav(s, builtin=false, unknown=0)
  oldplaywav((builtin ? "sound\\": "staredit\\wav\\") + s + ".wav", unknown)
end
def display(s, al=AlwaysDisplay)
  displaytextmessage(al, s)
end
def aiscript(s)
  if location?
    runaiscriptatlocation(location, s)
  else
    runaiscript(s)
  end
end
def center(loc=location)
  centerview(loc)
end
def ping(loc=location)
  minimapping(loc)
end
def pt
  preservetrigger
end

#some test cases
if false
p Opponents[8] > 1
p Timer[8] |1
p Men.kill>1
p kill>1
p AnyBuilding.kill.leaderboard
p Men.deaths[2]|5
p Men[4]>5
p Men+2
p Men|4 ############special test case
p Men.at("asd")|0
p Men[All].kill|0
p :zergling.at("1").most
p setshields(50)
p setresources
i=invincibility
p i[2].set
p invincibility.clear
p Switch[1].randomize
p Switch[2].off?
p Alliance[3]|Ally
p LBCPU.set
p Men[1].doodads.toggle.finalize
p Ore[2]<5
p Ore^2
p Gas.least
p Gas.leaderboardgoal(10, 'goal is 10')
p Custom>5
p move
p Men.at("2").leaderboard
p :zergling.teleport
p Buildings.at("ground").moveloc("t")
p :zergling.give(2,1)
puts Switch[3].off?.finalize
puts (:civ>1).finalize
end
